program Compiler;
{$APPTYPE CONSOLE}
{$H+}
uses
  SysUtils;
type
	TModificators = record
		isLocal:boolean;
		isPointer:boolean;
	end;
  Token = record
  	name:string;
    value:integer;
  end;

  Tokens = record
  	ArrToken:array of Token;
    size:integer;
  end;
  TStringList=array of string;

var
	InputFile:TextFile;
  CurrentToken:Token;
  code:TStringList;
  codeLine:integer;
  StringCount,IdCount: integer;
  Strings: array of string;
	VoidsLine: array of integer;
	tokenCount:integer;
	currentModify:TModificators;
procedure Init(FileName:string);
var
	i:integer;
begin
	Assign(inputfile,FileName);
  Reset(InputFile);
  codeLine:=0;
  setLength(code,1);
  readln(InputFile,StringCount,IdCount);
  tokenCount:=0;
  SetLength(Strings,StringCount);
  SetLength(VoidsLine,IdCount);
  for i:=0 to IdCount-1 do 
  	VoidsLine[i]:=-1;
  for i:=0 to StringCount-1 do
  	readln(InputFile,Strings[i]);

end;

function Next:token;
var
	s:string;
begin
	currentModify.isLocal:=false;
	currentModify.isPointer:=false;

	repeat 
		Readln(InputFile,s);
		inc(tokenCount);
	  Result.name:=copy(s,1,pos(#$FD,s)-1);
	  if Result.name='local' then begin
	  	currentModify.isLocal:=true;
	  end;

	  if Result.name='pointer' then begin
	  	currentModify.isPointer:=true;
	  end;
	  delete(s,1,pos(#$FD,s));
	until (Result.name<>'local') and (Result.name<>'pointer');

  result.value:=StrToIntDef(s,0);
end;

procedure out_result(FileName:string);
var
	i:integer;
  OutputFile:TextFile;
begin
	close(InputFile);
	Assign(OutputFile,Filename);
  Rewrite(OutputFile);
  writeln(OutputFile,IdCount);
	for i:=1 to codeLine do begin
  	writeln(OutputFile,code[i]);
  end;
  close(OutputFile);
end;

procedure addCode(st:string);
begin
	inc(codeLine);
  setLength(code,codeLine+1);
  code[codeLine]:=st;
end;

procedure changeCode(line:integer;st:string);
begin
	code[line]:=st;
end;

procedure copyOp(var first:integer;var buff:TStringList);
var
	i,j:integer;
begin
	SetLength(buff,codeLine-first+2);
  j:=codeline-first+1;
  for i:=first to codeLine do
  	buff[i-first+1]:=code[i];
  codeLine:=first-1;
  first:=j;
end;

procedure pasteOp(len:integer;buff:TStringList);
var
	i:integer;
begin
	inc(codeLine);
  setLength(code,codeLine+len+2);
	for i:=codeLine to codeLine+len-1 do
  	code[i]:=buff[i-codeline+1];
  codeline:=codeLine+len-1;
end;

function IdToStr(id:integer):string;
begin
	result:='$';
	if currentModify.isLocal then result := result+'&';
	if currentModify.isPointer then result := result+'@';
	result:=result+IntToStr(id);
end;

function NumberToStr(num:integer):string;
begin
	result:=IntToStr(num);
end;

procedure Fail;
begin
	
 	Raise Exception.Create('Compilation fail');
end;

procedure parse_operatorBlock; forward;
procedure parse_operator; forward;
procedure parse_operatorBody; forward;
procedure parse_expression; forward;
procedure parse_mul; forward;
procedure parse_pow; forward;
procedure parse_mono; forward;
procedure parse_number; forward;
procedure parse_BooleanExpression; forward;
procedure parse_void;forward;
procedure parse_int;forward;


procedure parse_program;
begin
	CurrentToken:=Next;
	addCode('nop');
	addCode('nop');
	while (CurrentToken.name='void') or (CurrentToken.name='int') do begin
//		writeln('pv');
		if CurrentToken.name='void' then begin
			parse_void;
		end
		else if CurrentToken.name='int' then begin
			parse_int;
		end;
//		writeln('epv');
	end;
  if CurrentToken.name<>'{' then
  	Fail;
	CurrentToken:=Next;
	changeCode(1,'jump '+IntToStr(codeLine+1));
  parse_operatorBody;
  if CurrentToken.name<>'}' then Fail;
	CurrentToken:=Next;
	addCode('stop');
end;


procedure parse_void;
var buff:array of string;
	last,i:integer;
begin
	if CurrentToken.name<>'void' then Fail;
	
	CurrentToken:=Next;
  if CurrentToken.name<>'id' then Fail;
  VoidsLine[CurrentToken.value]:=codeLine+1;
	addCode('nop void ' +IdToStr(CurrentToken.value) + ' start here');

	CurrentToken:=Next;
	if CurrentToken.name<>'(' then Fail;
	last:=0;
	SetLength(buff,0);
	CurrentToken:=Next;
	while CurrentToken.name<>')' do begin
		if CurrentToken.name<> 'id' then Fail;
		inc(last);
		SetLength(buff,last);
		buff[last-1] := 'pop '+IdToStr(CurrentToken.value);
		CurrentToken:=Next;
		if (CurrentToken.name<> ',')and(CurrentToken.name<> ')') then Fail;
		if (CurrentToken.name=',') then CurrentToken:=Next;
	end;
	for i:=last-1 downto 0 do 
		addCode(buff[i]);
	CurrentToken:=Next;
	if CurrentToken.name<>'{' then Fail;

  parse_operatorBlock;
	if CurrentToken.name=';' then CurrentToken:=Next;
	
	addCode('return');
end;

procedure parse_int;
var buff:array of string;
	last,i:integer;
begin
	if CurrentToken.name<>'int' then Fail;
	
	CurrentToken:=Next;
  if CurrentToken.name<>'id' then Fail;
  VoidsLine[CurrentToken.value]:=codeLine+1;
	addCode('nop void ' +IdToStr(CurrentToken.value) + ' start here');	

	CurrentToken:=Next;
	if CurrentToken.name<>'(' then Fail;
	last:=0;
	SetLength(buff,0);
	CurrentToken:=Next;
	while CurrentToken.name<>')' do begin
		if CurrentToken.name<> 'id' then Fail;
		inc(last);
		SetLength(buff,last);
		buff[last-1] := 'pop '+IdToStr(CurrentToken.value);
		CurrentToken:=Next;
		if (CurrentToken.name<> ',')and(CurrentToken.name<> ')') then Fail;
		if (CurrentToken.name=',') then CurrentToken:=Next;
	end;
	for i:=last-1 downto 0 do 
		addCode(buff[i]);
	CurrentToken:=Next;
	if CurrentToken.name<>'{' then Fail;

  parse_operatorBlock;
	if CurrentToken.name=';' then CurrentToken:=Next;	
	addCode('return');
end;


procedure parse_operatorBlock;
begin
	if CurrentToken.name='{' then begin
	  CurrentToken:=Next;
    parse_operatorBody;
    if CurrentToken.name<>'}' then Fail;
    CurrentToken:=Next;
	end
  else begin
  	parse_operator;
  end;
end;
procedure parse_operatorBody;
begin
	parse_operatorBlock;
  while CurrentToken.name=';' do begin
  	CurrentToken:=next;
    parse_operatorBlock;
  end;
end;


procedure parse_expression;
var
	op:string;
  isSign:boolean;
begin
	isSign:=False;
	if (CurrentToken.name='+')or(CurrentToken.name='-') then begin
  	if CurrentToken.name='-' then isSign:=true;
    CurrentToken:=Next;
  end;
  parse_mul;
  if isSign then addCode('sign');
  while (CurrentToken.name='+')or(CurrentToken.name='-') do begin
  	op:=CurrentToken.name;
    CurrentToken:=Next;
    parse_mul;
    if op='+' then addCode('add')
    else if op='-' then addCode('sub')
    else
    	Fail;
  end;
end;


procedure parse_mul;
var
  op:string;
begin
  parse_Pow;
  while (CurrentToken.name='*')or(CurrentToken.name='/')or(CurrentToken.name='%') do begin
    op:=CurrentToken.name;
    CurrentToken:=Next;
    parse_Pow;
    if op='*' then
    	AddCode('mul')
    else if op='/' then
    	AddCode('div')
    else if op='%' then
    	AddCode('mod');
  end;
end;

procedure parse_Pow;
begin
  parse_Mono;
  while CurrentToken.name = '^' do begin
    CurrentToken:=Next;
    parse_Pow;
    AddCode('pow');
  end;
end;

procedure parse_Mono;
begin
  if CurrentToken.name = '(' then
  begin
    CurrentToken:=Next;
    parse_Expression;
    if CurrentToken.name<>')' then
    	Fail;
    CurrentToken:=Next;
  end
  else
    parse_Number;
end;

procedure parse_Number;
var
	leftModify:TModificators;
	left:integer;
begin
  if CurrentToken.name='num' then begin
  	AddCode('push '+NumberToStr(CurrentToken.value));
    CurrentToken:=Next;
  end
  else if CurrentToken.name='readc' then begin
    CurrentToken:=Next;
    if CurrentToken.name<>'(' then fail;
    CurrentToken:=Next;
    if CurrentToken.name<>')' then fail;
    CurrentToken:=Next;
    addCode('readc');
	end
  else if CurrentToken.name='id' then begin
  	left := CurrentToken.value;
    leftModify := currentModify;

  	CurrentToken:=Next;
		if CurrentToken.name='(' then begin;
			CurrentToken:=Next;
			while CurrentToken.name<>')' do begin
				parse_expression;
				if (CurrentToken.name <> ',') and (CurrentToken.name <> ')') then Fail;
				if (CurrentToken.name = ',') then CurrentToken:=Next;
			end;
			CurrentToken:=Next;
			addCode('call '+IntToStr(VoidsLine[left]));
		end 
		else if CurrentToken.name = '~' then  begin
      currentModify := leftModify;
      AddCode('arrgetpointer ' + IdToStr(left));
			CurrentToken:=Next;
		end

		else if CurrentToken.name = '[' then  begin
      currentModify := leftModify;
			//if not currentModify.isArray then Fail;
			CurrentToken:=Next;
			if CurrentToken.name = '*' then begin
				CurrentToken:=Next;
				if CurrentToken.name<>']' then Fail;
				CurrentToken:=Next;
				currentModify := leftModify;
				AddCode('arrgetlen ' + IdToStr(left));
			end
			else begin
				parse_expression;
				if CurrentToken.name<>']' then Fail;
				CurrentToken:=Next;
	      currentModify := leftModify;
				AddCode('arrpush ' + IdToStr(left));
			end;
		end
		else begin
      currentModify := leftModify;
	  	AddCode('push ' + IdToStr(left));
	  end;
  end
  else
    Fail;
end;

procedure parse_BooleanExpression;
var
  op:string;
begin
  parse_Expression;
  if (CurrentToken.name<>'<=')and(CurrentToken.name<>'>=')and
  		(CurrentToken.name<>'=')and(CurrentToken.name<>'>')and
  		(CurrentToken.name<>'<')and(CurrentToken.name<>'!=') then 
  			Fail;
  op:=CurrentToken.name;
  CurrentToken:=Next;
  parse_Expression;
  if op='=' then AddCode('equal')
  else if op='<' then  AddCode('less')
  else if op='>' then  AddCode('more')
  else if op='!=' then  AddCode('noteq')
  else if op='<=' then  AddCode('lesseq')
  else if op='>=' then  AddCode('moreeq')
end;


procedure parse_operator;
var
	left:integer;
  changeCodeLine,StartIncLine,startLine,startOperatorBlockLine:integer;
  s:string;
	leftModify:TModificators;
  buff:TStringList;
  prefix:String;
begin
	with CurrentToken do begin
    if name='id' then begin
      leftModify := currentModify;
      left:=value;
      CurrentToken:=Next;
     	if name = '[' then  begin
        currentModify := leftModify;
				//if not currentModify.isArray then Fail;
				CurrentToken:=Next;
				parse_expression;
				if name<>']' then Fail;
        CurrentToken:=Next;
    	  currentModify := leftModify;
        prefix := 'arr';
			end
      else prefix:='';
      if name='~' then begin
        CurrentToken:=Next;
        parse_expression;
        currentModify := leftModify;
        addCode(prefix+'pop '+IdToStr(left));
      end
      else if (name='++') or (name='--') then begin
      	currentModify := leftModify;
        if prefix='arr' then AddCode('pushpoppop');
      	addCode(prefix + 'push '+IdToStr(left));
        addCode('push 1');
        if name='++' then
        	addCode('add')
        else if name='--' then
        	addCode('sub');
        CurrentToken:=Next;
        currentModify := leftModify;
        addCode(prefix + 'pop '+IdToStr(left));
      end
      else if (name='+=')or(name='-=')or(name='*=')or(name='/=') then begin
        if prefix='arr' then AddCode('pushpoppop');
        currentModify := leftModify;
      	addCode(prefix + 'push '+IdToStr(left));
        s:=name;
				CurrentToken:=Next;
        parse_expression;
        if s='+=' then
        	addCode('add')
        else if s='-=' then
        	addCode('sub')
        else if s='*=' then
        	addCode('mul')
        else if s='/=' then
        	addCode('div');
        currentModify := leftModify;
        addCode(prefix + 'pop '+IdToStr(left));

      end
      else if name='(' then begin
				CurrentToken:=Next;
				while name<>')' do begin
					parse_expression;
					if (name <> ',') and (name <> ')') then Fail;
					if (name = ',') then CurrentToken:=Next;
				end;
				CurrentToken:=Next;
				addCode('call '+IntToStr(VoidsLine[left]));
      end
      else
        Fail;
    end
    else if name='read' then begin
      addCode('read');
      CurrentToken:=Next;
      if name<>'(' then fail;
      CurrentToken:=Next;
      if name<>'id' then fail;
      addCode('pop '+IdToStr(value));
      CurrentToken:=Next;
      if name<>')' then fail;
      CurrentToken:=Next;
    end
    else if name='write' then begin
      CurrentToken:=Next;
      if name<>'(' then fail;
      CurrentToken:=Next;
      if name='str' then begin
	     	addCode('print "'+strings[value]+'"');
		  	CurrentToken:=Next;
      end
      else begin
      	parse_expression;
	      addCode('write');
      end;
      if name<>')' then fail;
      CurrentToken:=Next;
    end
    else if name='if' then begin
      CurrentToken:=Next;
      if name<>'(' then fail;
      CurrentToken:=Next;
      parse_BooleanExpression;
      if name<>')' then fail;
      CurrentToken:=Next;
      addCode('    (jfalse -)');
      startLine:=codeLine;
      parse_operatorBlock;
      changeCode(startLine,'jfalse '+IntToStr(codeLine+1));
    end
    else if name='while' then begin
      startLine:=codeLine+1;
      CurrentToken:=Next;
      if name<>'(' then fail;
      CurrentToken:=Next;
      parse_BooleanExpression;
      if name<>')' then fail;
      CurrentToken:=Next;
      addCode('    (jfalse -)');
      startOperatorBlockLine:=codeLine;
      parse_operatorBlock;
      addCode('jump '+IntToStr(startLine));
      changeCode(startOperatorBlockLine,'jfalse '+IntToStr(codeLine+1));
    end
    else if name='for' then begin
      CurrentToken:=Next;
      if name<>'(' then fail;
      CurrentToken:=Next;
      parse_operator;
      if name<>';' then fail;
      CurrentToken:=Next;

      startLine:=codeLine+1;
      parse_BooleanExpression;
      addcode('    (jfalse -)');
      changeCodeLine:=codeLine;
      if name<>';' then fail;
      CurrentToken:=Next;

      startIncLine:=codeLine+1;
      parse_operator;
      copyOp(startIncLine,buff);
      if name<>')' then fail;
      CurrentToken:=Next;
      parse_operatorBlock;

      pasteOp(startIncLine,buff);
      addCode('jump '+IntToStr(startLine));
      changeCode(changeCodeLine,'jfalse '+IntToStr(codeLine+1));
    end
    else if name='halt' then begin
        CurrentToken:=Next;
        addCode('stop');
    end
    else if name='return' then begin
      CurrentToken:=Next;
      if name=';' then begin
      	//void	
	    end
	    else begin
	    	parse_Expression;
	    end;

    	addCode('return');
    end
    else if name='writec' then begin
      CurrentToken:=Next;
      if name<>'(' then fail;
      CurrentToken:=Next;
     	parse_expression;
      addCode('writec');
      if name<>')' then fail;
      CurrentToken:=Next;
    end
    else if name='readc' then begin
      CurrentToken:=Next;
      if name<>'(' then fail;
      CurrentToken:=Next;
      if name<>')' then fail;
      CurrentToken:=Next;
      addCode('readc');
      addCode('pop ');
	  end
    else if name='' then begin
    end
    else if name='' then begin
    end;
  end;
end;

begin
	if ParamCount<>1 then begin
  	writeln('using: Compiler "FileName"');
    halt(1);
  end;
  init(ParamStr(1));
  try
  	parse_program;
  except
  	writeln('COMPILATION ERROR ',tokenCount+1+StringCount,' ',CurrentToken.name,' - ',CurrentToken.value);
    close(InputFile);
		halt(1);
	end;
  out_result(copy(ParamStr(1),1,length(ParamStr(1))-4)+'.executable');
//	Writeln('*********"COMPILATION OK"********');
end.
